/*
Copyright 2021 The SuperEdge authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "github.com/superedge/superedge/pkg/apps-manager/apis/apps/v1"
	scheme "github.com/superedge/superedge/pkg/apps-manager/generated/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// EDeploymentsGetter has a method to return a EDeploymentInterface.
// A group's client should implement this interface.
type EDeploymentsGetter interface {
	EDeployments(namespace string) EDeploymentInterface
}

// EDeploymentInterface has methods to work with EDeployment resources.
type EDeploymentInterface interface {
	Create(ctx context.Context, eDeployment *v1.EDeployment, opts metav1.CreateOptions) (*v1.EDeployment, error)
	Update(ctx context.Context, eDeployment *v1.EDeployment, opts metav1.UpdateOptions) (*v1.EDeployment, error)
	UpdateStatus(ctx context.Context, eDeployment *v1.EDeployment, opts metav1.UpdateOptions) (*v1.EDeployment, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.EDeployment, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.EDeploymentList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.EDeployment, err error)
	EDeploymentExpansion
}

// eDeployments implements EDeploymentInterface
type eDeployments struct {
	client rest.Interface
	ns     string
}

// newEDeployments returns a EDeployments
func newEDeployments(c *AppsV1Client, namespace string) *eDeployments {
	return &eDeployments{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the eDeployment, and returns the corresponding eDeployment object, and an error if there is any.
func (c *eDeployments) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.EDeployment, err error) {
	result = &v1.EDeployment{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("edeployments").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of EDeployments that match those selectors.
func (c *eDeployments) List(ctx context.Context, opts metav1.ListOptions) (result *v1.EDeploymentList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.EDeploymentList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("edeployments").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested eDeployments.
func (c *eDeployments) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("edeployments").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a eDeployment and creates it.  Returns the server's representation of the eDeployment, and an error, if there is any.
func (c *eDeployments) Create(ctx context.Context, eDeployment *v1.EDeployment, opts metav1.CreateOptions) (result *v1.EDeployment, err error) {
	result = &v1.EDeployment{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("edeployments").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(eDeployment).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a eDeployment and updates it. Returns the server's representation of the eDeployment, and an error, if there is any.
func (c *eDeployments) Update(ctx context.Context, eDeployment *v1.EDeployment, opts metav1.UpdateOptions) (result *v1.EDeployment, err error) {
	result = &v1.EDeployment{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("edeployments").
		Name(eDeployment.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(eDeployment).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *eDeployments) UpdateStatus(ctx context.Context, eDeployment *v1.EDeployment, opts metav1.UpdateOptions) (result *v1.EDeployment, err error) {
	result = &v1.EDeployment{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("edeployments").
		Name(eDeployment.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(eDeployment).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the eDeployment and deletes it. Returns an error if one occurs.
func (c *eDeployments) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("edeployments").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *eDeployments) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("edeployments").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched eDeployment.
func (c *eDeployments) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.EDeployment, err error) {
	result = &v1.EDeployment{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("edeployments").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
