/*
Copyright 2020 The SuperEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	time "time"

	nodetaskappssuperedgeiov1beta1 "github.com/superedge/superedge/pkg/penetrator/apis/nodetask.apps.superedge.io/v1beta1"
	versioned "github.com/superedge/superedge/pkg/penetrator/client/clientset/versioned"
	internalinterfaces "github.com/superedge/superedge/pkg/penetrator/client/informers/externalversions/internalinterfaces"
	v1beta1 "github.com/superedge/superedge/pkg/penetrator/client/listers/nodetask.apps.superedge.io/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// NodeTaskInformer provides access to a shared informer and lister for
// NodeTasks.
type NodeTaskInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1beta1.NodeTaskLister
}

type nodeTaskInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewNodeTaskInformer constructs a new informer for NodeTask type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewNodeTaskInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredNodeTaskInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredNodeTaskInformer constructs a new informer for NodeTask type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredNodeTaskInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.NodestaskV1beta1().NodeTasks().List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.NodestaskV1beta1().NodeTasks().Watch(context.TODO(), options)
			},
		},
		&nodetaskappssuperedgeiov1beta1.NodeTask{},
		resyncPeriod,
		indexers,
	)
}

func (f *nodeTaskInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredNodeTaskInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *nodeTaskInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&nodetaskappssuperedgeiov1beta1.NodeTask{}, f.defaultInformer)
}

func (f *nodeTaskInformer) Lister() v1beta1.NodeTaskLister {
	return v1beta1.NewNodeTaskLister(f.Informer().GetIndexer())
}
